unit Unit6;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ImgList, StdCtrls, Buttons, OleCtrls, SHDocVw,
  ExtCtrls, Menus, ShlObj, ShellAPI;

type
  TForm6 = class(TForm)
    ImageList1: TImageList;
    Panel1: TPanel;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    Label1: TLabel;
    edtEndereco: TEdit;
    BitBtn1: TBitBtn;
    WebBrowser1: TWebBrowser;
    PopupMenu1: TPopupMenu;
    VisualizarImpresso1: TMenuItem;
    Imprimir1: TMenuItem;
    Configurapgina1: TMenuItem;
    N1: TMenuItem;
    PopupMenu2: TPopupMenu;
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure edtEnderecoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Configurapgina1Click(Sender: TObject);
    procedure VisualizarImpresso1Click(Sender: TObject);
    procedure Imprimir1Click(Sender: TObject);
    procedure WebBrowser1NavigateComplete2(ASender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure FormShow(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
  private
    procedure Favoritos(const caminho: string; StrList: TStrings);
    procedure PreencheMenu(Sender: TObject);
    procedure DoOnClick(Sender : TObject);
    { Private declarations }
  public
    pidl : PItemIDList;
    caminho : array[0..MAX_PATH] of char;
    procedure Navegar(link: string);
    { Public declarations }
  end;

var
  Form6: TForm6;

implementation

{$R *.dfm}

procedure TForm6.BitBtn1Click(Sender: TObject);
begin
  WebBrowser1.Navigate(edtEndereco.Text);
end;

procedure TForm6.Configurapgina1Click(Sender: TObject);
var
  vIn, vOut: OleVariant;
begin
  WebBrowser1.ControlInterface.ExecWB(OLECMDID_PAGESETUP, OLECMDEXECOPT_PROMPTUSER, vIn, vOut);
end;

procedure TForm6.DoOnClick(Sender: TObject);
var
  site : string;
begin
  { Pega o valor do item atravs da propriedade Caption }
  site := (Sender as TMenuItem).Caption;
  site := StringReplace(site, '&', '', [rfReplaceAll]);
  edtEndereco.Text := site;
  WebBrowser1.Navigate(site);
end;

procedure TForm6.edtEnderecoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_RETURN then
    WebBrowser1.Navigate(edtEndereco.Text);
end;

procedure TForm6.FormShow(Sender: TObject);
begin
  edtEndereco.Text := 'http:\\www.lucianopimenta.net';
  WebBrowser1.Navigate('www.lucianopimenta.net');

  SHGetSpecialFolderLocation(Handle, CSIDL_FAVORITES, pidl);
  SHGetPathFromIDList(pidl, caminho);
  PreencheMenu(sender);
end;

procedure TForm6.Imprimir1Click(Sender: TObject);
var
  vIn, vOut: OleVariant;
begin
  WebBrowser1.ControlInterface.ExecWB(OLECMDID_PRINT, OLECMDEXECOPT_DONTPROMPTUSER, vIn, vOut) ;
end;

procedure TForm6.Navegar(link: string);
begin
  WebBrowser1.Navigate(link);
  edtEndereco.Text := link;
end;

procedure TForm6.ToolButton1Click(Sender: TObject);
begin
  WebBrowser1.GoBack;
end;

procedure TForm6.ToolButton2Click(Sender: TObject);
begin
  WebBrowser1.GoForward;
end;

procedure TForm6.ToolButton3Click(Sender: TObject);
begin
  WebBrowser1.GoHome;
end;

procedure TForm6.ToolButton6Click(Sender: TObject);
var
  vIn, vOut: OleVariant;
begin
  WebBrowser1.ControlInterface.ExecWB(OLECMDID_FIND, OLECMDEXECOPT_PROMPTUSER, vIn, vOut) ;
end;

procedure TForm6.VisualizarImpresso1Click(Sender: TObject);
var
  vIn, vOut: OleVariant;
begin
  WebBrowser1.ControlInterface.ExecWB(OLECMDID_PRINTPREVIEW, OLECMDEXECOPT_DONTPROMPTUSER, vIn, vOut) ;
end;

procedure TForm6.WebBrowser1NavigateComplete2(ASender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  edtEndereco.Text := URL;
end;

procedure TForm6.Favoritos(const caminho: string; StrList: TStrings);
var
  searchrec: TSearchrec;
  path, dir, arquivo: string;
  Buffer: array[0..2047] of Char;
  found: Integer;
begin
  path := caminho +'\*.url';
  dir := ExtractFilepath(path);
  found := FindFirst(path, faAnyFile, searchrec);
  while found = 0 do
  begin
    SetString(arquivo, Buffer,
      GetPrivateProfileString('InternetShortcut',
      PChar('URL'), nil, Buffer, SizeOf(Buffer),
      PChar(dir + searchrec.Name)));
    StrList.Add(arquivo);
    found := FindNext(searchrec);
  end;
  found := FindFirst(dir +'\*.*', faAnyFile, searchrec);
  while found = 0 do
  begin
    if ((searchrec.Attr and faDirectory) > 0) and
      (searchrec.Name[1]<>'.') then
      Favoritos(dir + '\'+searchrec.name, StrList);
    found := FindNext(searchrec);
  end;
  FindClose(searchrec);
end;


procedure TForm6.PreencheMenu(Sender: TObject);
var
  lista: TStrings;
  i: integer;
  Item: TMenuItem;
begin
  lista := TStringList.Create;  
  try
    PopupMenu2.Items.Clear;
    Favoritos(StrPas(caminho), lista);
    if lista.Count > 0 then
    begin
      for i := 0 to lista.Count - 1 do
      begin
        Item := TMenuItem.Create(self);
        Item.Caption := lista.Strings[i];
        Item.OnClick := DoOnClick;
        PopupMenu2.Items.Add(Item);
      end;
    end
    else
    begin
      Item := TMenuItem.Create(self);
      Item.Caption := 'Nenhum Favorito cadastrado';
      PopupMenu2.Items.Add(Item);
    end;
  finally
    lista.Free;
  end;
end;


end.
