unit uCadPresenca;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uFrmModeloCad, StdCtrls, Buttons, ExtCtrls, Grids, DBGrids, DB,
  DBClient, JPEG;

type
  TfrmCadPresenca = class(TfrmModeloCad)
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    GroupBox1: TGroupBox;
    lblNumReg: TLabel;
    rNomeEvento: TLabel;
    rDataHora: TLabel;
    cds: TClientDataSet;
    cdsCOL1: TStringField;
    cdsCOL2: TStringField;
    cdsFOTO: TBlobField;
    ds: TDataSource;
    pDigitacao: TPanel;
    eParticipante: TEdit;
    btLocalizaPessoa: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cdsAfterPost(DataSet: TDataSet);
    procedure eParticipanteKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btLocalizaPessoaClick(Sender: TObject);
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
  private
    procedure Recomeca;
    procedure insere_registro_local;
    { Private declarations }
  public
    procedure RegistraPresenca;
    { Public declarations }
  end;

var
  frmCadPresenca: TfrmCadPresenca;

implementation

uses uDM, uLib, uConsPessoa;

{$R *.dfm}

procedure TfrmCadPresenca.btLocalizaPessoaClick(Sender: TObject);
begin
  inherited;
  //"diz"  varivel que "nada" foi selecionado
  CodPessoa := -1;
  //chama o formulrio de pesquisa
  AbreFormCons(TfrmConsPessoa, frmConsPessoa);
  //checa se foi selecionado algo
  if CodPessoa>0 then
  begin
    //preenche o o cdigo selecionado no Edit
    eParticipante.Text := IntToStr(CodPessoa);
    //e registra a presena
    RegistraPresenca;
  end
  else //se no selecionou nada, recomea
    Recomeca;
end;

procedure TfrmCadPresenca.cdsAfterPost(DataSet: TDataSet);
begin
  inherited;
  lblNumReg.Caption := IntToStr(cds.RecordCount);
end;

procedure TfrmCadPresenca.DBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
var
  MemStrm: TMemoryStream;
  Jpg: TJPEGImage;
  Bmp: TBitmap;
  P: TPicture;
  R: TRect;
begin
  inherited;

  // *** DBGrid zebrado ***
  // se for mpar
  if not odd(cds.RecNo) then
    // se a clula no est selecionada
    if not (gdSelected in State) then
    begin
      // define uma cor de fundo
      DBGrid1.Canvas.Brush.Color:=$00FFEFDF;
      // pinta a clula
      DBGrid1.Canvas.FillRect(Rect);
      // pinta o texto padro
      DBGrid1.DefaultDrawDataCell(rect,Column.Field,State);
    end;

  // *** exibe campos memo / com quebras de linha ***
  //COL1
  R := Rect;
  Dec(R.Bottom,2);
  if Column.Field = cdsCOL1 then
  begin
    DBGrid1.Canvas.FillRect(Rect);
    DrawText(DBGrid1.Canvas.Handle,
      pchar(cdsCOL1.AsString),
      length(cdsCOL1.AsString),
      R,DT_WORDBREAK);
  end;

  //COL1
  R := Rect;
  Dec(R.Bottom,2);
  if Column.Field = cdsCOL2 then
  begin
    DBGrid1.Canvas.FillRect(Rect);
    DrawText(DBGrid1.Canvas.Handle,
      pchar(cdsCOL2.AsString),
      length(cdsCOL2.AsString),
      R,DT_WORDBREAK);
  end;

  // *** pinta o campo foto ***
  if (Column.Field = cdsFOTO) then
  begin
    // limpa a clula
    DBGrid1.Canvas.FillRect(Rect);

    //se o campo FOTO no est Nulo
    if (not cdsFOTO.IsNull) then
    begin
      //prepara para colocar a foto em memria
      P := TPicture.Create;
      try
        try
          Jpg := TJPEGImage.Create;
          try
            MemStrm := TMemoryStream.Create;
            try
              Bmp := TBitmap.Create;
              try
                //joga a foto na memria
                cdsFOTO.SaveToStream(MemStrm);
                MemStrm.Seek(0,soFromBeginning);
                Jpg.PixelFormat := jf24Bit;
                Jpg.Scale := jsFullSize;
                Jpg.Grayscale := False;
                Jpg.Performance := jpBestQuality;
                Jpg.ProgressiveDisplay := True;
                Jpg.ProgressiveEncoding := True;

                try
                  Jpg.LoadFromStream(MemStrm);
                  Bmp.Assign(Jpg);
                except
                  try
                    Bmp.Assign(cdsFOTO);
                  except
                  end;
                end;

                P.Assign(Bmp);
                // desenha imagem na grade
                DBGrid1.Canvas.StretchDraw(Rect,P.Bitmap);
              finally
                Bmp.Free;
              end;
            finally
              MemStrm.Free;
            end;
          finally
            Jpg.Free;
          end;
        except
        end;
      finally
        P.Free;
      end;
    end;
  end;
end;

procedure TfrmCadPresenca.eParticipanteKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  inherited;
  if key = vk_f3 then
    btLocalizaPessoa.Click
  else if key = VK_RETURN then
    RegistraPresenca;
end;

procedure TfrmCadPresenca.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  cds.EmptyDataSet;
  cds.Close;
end;

procedure TfrmCadPresenca.FormCreate(Sender: TObject);
begin
  inherited;
  Top := 0;
  Left := 0;
  WindowState := wsMaximized;
end;

procedure TfrmCadPresenca.FormShow(Sender: TObject);
begin
  inherited;
  rNomeEvento.Caption := dm.cdsEventoNOME.AsString;
  rDataHora.Caption := 'Data: ' + dm.cdsEventoDATA.AsString +
                  '     Hora: ' + dm.cdsEventoHORA.AsString;

  if pDigitacao.Visible then
  begin
    eParticipante.Clear;
    eParticipante.SetFocus;
  end;
end;

procedure TfrmCadPresenca.Recomeca;
begin
  dm.cdsPessoa.Close;
  eParticipante.Clear;
  if pDigitacao.Visible then
  begin
    eParticipante.SetFocus;
    abort;
  end;
end;

procedure TfrmCadPresenca.insere_registro_local;
begin
  //desativa os controles da grade
  cds.DisableControls;
  try
    //vai para a primeira linha
    cds.First;
    //insere um registro naquela posio
    cds.Insert;
    //preenche a primeira colunas com alguns dados
    cdsCOL1.Value := 'Cdigo: ' + dm.cdsPessoaCODPESSOA.AsString + #13#10 +
      'Nome: ' + dm.cdsPessoaAPELIDO.AsString + #13#10 +
      'CPF: ' + dm.cdsPessoaCPF.AsString + #13#10 +
      'RG: ' + dm.cdsPessoaRG.AsString;
    //preenche a segunda coluna com mais alguns dados
    cdsCOL2.Value := 'Inscrito Em: ' + dm.cdsPessoaINSCRICAO.AsString + #13#10 +
      NOME_GRUPO1 + ': ' + dm.cdsPessoaGRUPO1.AsString + '-' + dm.cdsPessoaNOMEGRUPO1.AsString + #13#10 +
      NOME_GRUPO2 + ': ' + dm.cdsPessoaGRUPO2.AsString + '-' + dm.cdsPessoaNOMEGRUPO2.AsString;
    //preenche a foto
    cdsFOTO.Value := dm.cdsPessoaFOTO.Value;
    //salva o registro na memria
    cds.Post;
  finally
    //reativa os controles da grade
    cds.EnableControls;
  end;
end;

procedure TfrmCadPresenca.RegistraPresenca;
begin
  //se no preencheu nada, recomea
  if Trim(eParticipante.Text) = '' then
    Recomeca;

  with dm.cdsPessoa do
  begin
    //localiza a pessoa pelo cdigo informado (ou lido no crach)
    Close;
    Params.ParamByName('PORNOME').Value := 0;
    Params.ParamByName('PORCODIGO').Value := 1;
    Params.ParamByName('NOME').Clear;
    Params.ParamByName('CODPESSOA').Value := eParticipante.Text;
    Open;

    //se encontrou
    if (not IsEmpty) then
    begin
      //se est registrando presena
      if pDigitacao.Visible then
      begin
        //verifica se a pessoa se inscreveu no evento, localizando nas suas
        //inscries o cdigo do evento em que esto sendo registras as presenas
        dm.cdsParticipacoes.First;
        if not dm.cdsParticipacoes.Locate(
          'CODEVENTO', dm.cdsEventoCODEVENTO.AsString, []) then
        begin
          Alerta('         * * *   PARTICIPANTE NO INSCRITO   * * *' + #13#10#13#10 +
            'O Participante Informado No Est Inscrito Neste Evento!');
          Recomeca;
        end;
      end;

      //verifica se o participante j registrou presena
      if pDigitacao.Visible and dm.cdsParticipacoesPRESENTE.AsBoolean then
      begin
        Alerta('Presena J Confirmada Neste Evento Para o Participante Informado!');
        Recomeca;
      end;

      //verifica se j foi efetuado o pagamento (obs: mesmo que seja um evento
      //sem valor, o campo PAGOEM ter a data do "pagamento", que neste caso
      //ser a mesma data da inscrio.
      if pDigitacao.Visible and
         (dm.cdsParticipacoesPAGOEM.IsNull or
         (dm.cdsParticipacoesPAGOEM.AsString = '30/12/1899')) then
      begin
        Alerta('           * * *   INSCRIO NO PAGA   * * *' + #13#10#13#10 +
          'A Inscrio Do Participante Neste Evento No Foi Paga!');
        Recomeca;
      end;

      //se no parou em nenhuma validao, registra no banco de dados
      //a presena da pessoa neste evento
      if pDigitacao.Visible then
      begin
        dm.cdsParticipacoes.Edit;
        dm.cdsParticipacoesPRESENTE.Value := 'T';
        dm.cdsParticipacoes.Post;
        dm.Gravar(dm.cdsPessoa);
      end;

      //insere na tabela temporria, para exibio na grade os dados da pessoa
      try insere_registro_local; except end;

      Recomeca;
    end
    else //se no encontrou, alerta o usurio
    begin
      if pDigitacao.Visible then
        Alerta('Participante No Encontrado!' + #13#10 +
               'Verifique o Cdigo Informado.');
      Recomeca;
    end;
  end;
end;

end.
