unit uFrmPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  ActnList, PlatformDefaultStyleActnCtrls, ActnMan, Ribbon,
  RibbonLunaStyleActnCtrls, ToolWin, ActnCtrls, ActnMenus, RibbonActnMenus,
  ImgList, ComCtrls, ExtCtrls, ShellApi;

type
  TfrmPrincipal = class(TForm)
    ActionManager1: TActionManager;
    actConfiguracoes: TAction;
    actLogAcoes: TAction;
    actSair: TAction;
    actGrupo1: TAction;
    actGrupo2: TAction;
    actEventos: TAction;
    actPessoas: TAction;
    actRecebimentos: TAction;
    actSorteio: TAction;
    actNotePad: TAction;
    actCalc: TAction;
    actInternet: TAction;
    Ribbon1: TRibbon;
    RibbonPage1: TRibbonPage;
    RibbonPage2: TRibbonPage;
    RibbonPage3: TRibbonPage;
    RibbonGroup1: TRibbonGroup;
    RibbonGroup2: TRibbonGroup;
    RibbonGroup3: TRibbonGroup;
    RibbonGroup4: TRibbonGroup;
    RibbonApplicationMenuBar1: TRibbonApplicationMenuBar;
    actSobre: TAction;
    ImageList16: TImageList;
    ImageList32: TImageList;
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    procedure FormResize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Ribbon1HelpButtonClick(Sender: TObject);
    procedure actGrupo1Execute(Sender: TObject);
    procedure actGrupo2Execute(Sender: TObject);
    procedure actEventosExecute(Sender: TObject);
    procedure actPessoasExecute(Sender: TObject);
    procedure actSobreExecute(Sender: TObject);
    procedure actSairExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure actRecebimentosExecute(Sender: TObject);
    procedure actSorteioExecute(Sender: TObject);
    procedure actConfiguracoesExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPrincipal: TfrmPrincipal;

implementation

uses uDM, uConsGrupo1, uLib, uConsGrupo2, uConsEvento, uConsPessoa,
  uRecebimento, uSorteio, uSisConf;

{$R *.dfm}

procedure TfrmPrincipal.actConfiguracoesExecute(Sender: TObject);
begin
  frmSisConf := TfrmSisConf.Create(Self);
  try
    if not dm.cdsSis.Active then
      dm.cdsSis.Open;
    if dm.cdsSis.IsEmpty then
    begin
      dm.cdsSis.Append;
      dm.cdsSisID.Value := 0;
      dm.cdsSisONENTER_COLOR.Value := clSkyBlue;
      dm.cdsSisCONGRESSO.Value := 'NOME DO CONGRESSO';
      dm.cdsSisGRUPO1.Value := 'NOME DO GRUPO1';
      dm.cdsSisGRUPO2.Value := 'NOME DO GRUPO2';
    end
    else
      dm.cdsSis.Edit;

    frmSisConf.ShowModal;
  finally
    frmSisConf.Release;
    dm.carrega_configuracoes;
  end;
end;

procedure TfrmPrincipal.actEventosExecute(Sender: TObject);
begin
  AbreForm(TfrmConsEvento, frmConsEvento);
end;

procedure TfrmPrincipal.actGrupo1Execute(Sender: TObject);
begin
  AbreForm(TfrmConsGrupo1, frmConsGrupo1);
end;

procedure TfrmPrincipal.actGrupo2Execute(Sender: TObject);
begin
  AbreForm(TfrmConsGrupo2, frmConsGrupo2);
end;

procedure TfrmPrincipal.actPessoasExecute(Sender: TObject);
begin
  AbreForm(TfrmConsPessoa, frmConsPessoa);
end;

procedure TfrmPrincipal.actRecebimentosExecute(Sender: TObject);
begin
  //instancia o formulrio de recebimento
  frmRecebimento := TfrmRecebimento.Create(Self);
  try
    //oculta o form. Principal
    frmPrincipal.Visible := False;
    try
      //exibe o form de Recebimento
      frmRecebimento.ShowModal;
    finally
      //Aps encerrar o form de Recebimento,
      //volta o form. Principal
      frmPrincipal.Visible := True;
    end;
  finally
    //libera o form. de Recebimento da memria
    frmRecebimento.Release;
  end;
end;

procedure TfrmPrincipal.actSairExecute(Sender: TObject);
begin
  Close;
end;

procedure TfrmPrincipal.actSobreExecute(Sender: TObject);
begin
  ShellAbout(Handle,
    'Controle de Eventos 1.0',
    'ActiveDelphi - Kelver Merlotti' + #13#10 + 'www.activedelphi.com.br',
    Application.Icon.Handle);
end;

procedure TfrmPrincipal.actSorteioExecute(Sender: TObject);
begin
  frmSorteio := TfrmSorteio.Create(Self);
  try
    frmPrincipal.Visible := False;
    try
      frmSorteio.ShowModal;
    finally
      frmPrincipal.Visible := True;
    end;
  finally
    frmSorteio.Release;
  end;
end;

procedure TfrmPrincipal.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled := False;
end;

procedure TfrmPrincipal.FormResize(Sender: TObject);
begin
  StatusBar1.Panels[0].Width := ClientWidth - 275;
end;

procedure TfrmPrincipal.FormShow(Sender: TObject);
begin
  Timer1Timer(Timer1);
  actGrupo1.Caption := NOME_GRUPO1;
  actGrupo2.Caption := NOME_GRUPO2;
end;

procedure TfrmPrincipal.Ribbon1HelpButtonClick(Sender: TObject);
begin
  ShellAbout(Handle,
    'Controle de Eventos 1.0',
    'ActiveDelphi - Kelver Merlotti',
    Application.Icon.Handle);
end;

procedure TfrmPrincipal.Timer1Timer(Sender: TObject);
begin
  TRY StatusBar1.Panels[1].Text := FormatDateTime('dddddd - HH:NN:SS', Now); EXCEPT END;
end;

end.
