unit uRecebimento;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uFrmModeloCad, StdCtrls, Buttons, ExtCtrls, Mask, DBCtrls, Grids,
  DBGrids, DB, DBClient, ImgList;

type
  TfrmRecebimento = class(TfrmModeloCad)
    pEventos: TPanel;
    pRecebimento: TPanel;
    pCabecalho: TPanel;
    Label6: TLabel;
    eParticipante: TEdit;
    btLocalizaPessoa: TBitBtn;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    lGrupo1: TLabel;
    DBEdit6: TDBEdit;
    DBEdit7: TDBEdit;
    lGrupo2: TLabel;
    DBEdit8: TDBEdit;
    DBEdit9: TDBEdit;
    Label4: TLabel;
    gParticipacoes: TDBGrid;
    Label7: TLabel;
    eReceber: TEdit;
    Label9: TLabel;
    eRecebido: TEdit;
    Label10: TLabel;
    eDiferenca: TEdit;
    dsP: TDataSource;
    cdsP: TClientDataSet;
    cdsPPARTICIPA: TStringField;
    cdsPCODEVENTO: TIntegerField;
    cdsPNOMEEVENTO: TStringField;
    cdsPVALOR: TFloatField;
    cdsPDATAPGTO: TDateField;
    cdsPPRESENTE: TStringField;
    cdsPAPAGAR: TAggregateField;
    cdsPDATA: TDateField;
    cdsPHORA: TStringField;
    bConfirmaPgto: TBitBtn;
    ImageList1: TImageList;
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure eParticipanteKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btLocalizaPessoaClick(Sender: TObject);
    procedure cdsPAfterPost(DataSet: TDataSet);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure cdsPCODEVENTOGetText(Sender: TField; var Text: string;
      DisplayText: Boolean);
    procedure gParticipacoesDblClick(Sender: TObject);
    procedure gParticipacoesKeyPress(Sender: TObject; var Key: Char);
    procedure gParticipacoesDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure eRecebidoEnter(Sender: TObject);
    procedure eRecebidoExit(Sender: TObject);
    procedure bConfirmaPgtoClick(Sender: TObject);
    procedure btCancelarClick(Sender: TObject);
  private
    procedure Recomeca;
    procedure CarregaDados;
    procedure calcula_diferenca;
    procedure calcula_valores;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRecebimento: TfrmRecebimento;

implementation

uses uDM, uLib, uConsPessoa;

{$R *.dfm}

procedure TfrmRecebimento.calcula_diferenca;
var
  dif: Real;
begin
  //encontra a diferena
  dif := StrToFloat(eRecebido.Text) - StrToFloat(eReceber.Text);
  //formata o valor absoluto, caso a diferena seja negativa
  eDiferenca.Text := FormatFloat('#,##0.00', Abs(dif));
  //sendo negativa, alerta o usurio
  if dif < 0 then
  begin
    Alerta('O Valor Recebido  Menor que o Valor a Receber.' + #13#10#13#10 +
      'Corrija-o ou selecione menos eventos.');
    eRecebido.Text := eReceber.Text;
    eRecebido.SelectAll;
    eRecebido.SetFocus;
    abort;
  end;
end;

procedure TfrmRecebimento.calcula_valores;
var
  R: TBookMark;
begin
  //pega a posio atual do cdsP
  R := cdsP.GetBookmark;

  //desativa os controles
  cdsP.DisableControls;
  try
    //filtra somente os registros que foram marcados para Pagar
    cdsP.Filtered := False;
    cdsP.Filter := 'PARTICIPA = ''T''';
    cdsP.Filtered := True;

    //se o campo aggregate est preenchido,  porque algo foi selecionado
    if (cdsPAPAGAR.IsNull) or (cdsPAPAGAR.AsString = '') then
      eReceber.Text := '0,00'
    else
      eReceber.Text := FormatFloat('#,##0.00', cdsPAPAGAR.Value);
    //considera primeiramente o valor devido como recebido, para facilitar
    //a vida do operador :)
    eRecebido.Text := eReceber.Text;
    //zera a diferena, j que so os mesmos valores
    eDiferenca.Text := '0,00';

    //anula o filtro inicial (apenas dos selecionados)
    cdsP.Filtered := False;
    cdsP.Filter := '';
  finally
    //reativa os controles
    cdsP.EnableControls;
  end;

  //volta o cursor na posio original
  try cdsP.GotoBookmark(R); except end;
  try cdsP.FreeBookmark(R); except end;

  //executa o mtodo que calcula a diferena entre os valores devido e pago
  calcula_diferenca;
end;

procedure TfrmRecebimento.Recomeca;
begin
  //limpa o cdsP
  cdsP.EmptyDataSet;
  //fecha o cdsPessoa
  dm.cdsPessoa.Close;
  //limpa os campos de valores
  eReceber.Text := '0,00';
  eRecebido.Text := '0,00';
  eDiferenca.Text := '0,00';
  //limpa o campo de pesquisa de pessoa
  eParticipante.Clear;
  //e posiciona o foco na pesquisa
  eParticipante.SetFocus;
  abort;
end;

procedure TfrmRecebimento.CarregaDados;
var
  //varivel que guardar a data e a hora do evento
  //para posterior insero no cdsP
  lstDataHora: TStringList;
begin
  //se no tem pessoa pesquisada, recomea
  if Trim(eParticipante.Text) = '' then
    Recomeca;

  //desativa os controles ligados ao cdsP
  cdsP.DisableControls;
  try
    //esvazia o cdsP
    cdsP.EmptyDataSet;
    with dm.cdsPessoa do
    begin
      //pesquisa a pessoa informada pelo cdigo
      Close;
      Params.ParamByName('PORNOME').Value := 0;
      Params.ParamByName('PORCODIGO').Value := 1;
      Params.ParamByName('NOME').Clear;
      Params.ParamByName('CODPESSOA').Value := eParticipante.Text;
      Open;

      //se encontrou algum
      if (not IsEmpty) then
      begin
        //filtra seus eventos no pagos
        dm.cdsParticipacoes.Filtered := False;
        dm.cdsParticipacoes.Filter := '(PAGOEM IS NULL) OR (PAGOEM = 0)';
        dm.cdsParticipacoes.Filtered := True;
        //caso no haja mais eventos em aberto, exibe o alerta e encerra
        if dm.cdsParticipacoes.IsEmpty then
        begin
          Alerta('No H Inscries Em Aberto para o Participante Informado!');
          Recomeca;
          exit;
        end;

        //caso haja, desvincula o evento AfterPost do cdsP para evitar uma
        //sobrecarga desnecessria de processamento, pois ir inserir vrios
        //registros ao seguidos e s depois  que ser necessrio calcular
        //os valores:
        cdsP.AfterPost := nil;
        lstDataHora := TStringList.Create;
        try
          while not dm.cdsParticipacoes.Eof do
          begin
            cdsP.Append;
            cdsPPARTICIPA.Value := 'T';
            cdsPCODEVENTO.Value := dm.cdsParticipacoesCODEVENTO.Value;
            cdsPNOMEEVENTO.Value := dm.cdsParticipacoesNOME.Value;
            cdsPVALOR.Value := dm.cdsParticipacoesVALOR.AsFloat;
            cdsPPRESENTE.Value := dm.cdsParticipacoesPRESENTE.Value;
            //recupera a Data e a Hora do Evento atravs do mtodo GetFieldsByID
            //existente na uLib
            lstDataHora.CommaText := GetFieldsByID(dm.Banco, 'EVENTOS',
              'DATA;HORA', 'CODEVENTO', dm.cdsParticipacoesCODEVENTO.AsInteger);
            cdsPDATA.AsString := lstDataHora[0];
            cdsPHORA.AsString := lstDataHora[1];
            cdsP.Post;
            dm.cdsParticipacoes.Next;
            //limpa os campos de data e hora da lista para o prximo evento
            lstDataHora.Clear;
          end;
        finally
          //retoma o vnculo do AfterPost do cdsP
          cdsP.AfterPost := cdsPAfterPost;
          //libera a lista da memria
          lstDataHora.Free;
        end;

        //Elimina o filtro das participaes da pessoa, feito no incio
        dm.cdsParticipacoes.Filtered := False;
        dm.cdsParticipacoes.Filter := '';
        dm.cdsParticipacoes.First;

        //calcula o valor devido
        calcula_valores;
        cdsP.First;
      end
      else //se no encontrou ningum com o cdigo especificado
      begin
        //exibe o alerta e recomea
        Alerta('Participantes No Encontrado!');
        Recomeca;
      end;
    end;
  finally
    //reativa os controles ligados ao cdsP
    cdsP.EnableControls;
  end;
end;

procedure TfrmRecebimento.cdsPAfterPost(DataSet: TDataSet);
begin
  inherited;
  calcula_valores;
end;

procedure TfrmRecebimento.cdsPCODEVENTOGetText(Sender: TField; var Text: string;
  DisplayText: Boolean);
begin
  inherited;
  //se o campo cdigo est preechido, exibe-o junto com o nome
  if Sender.AsString <> '' then
    Text := Sender.AsString + '-' + cdsPNOMEEVENTO.Value
  else
    Text := '';
end;

procedure TfrmRecebimento.bConfirmaPgtoClick(Sender: TObject);
var
  data_pgto: TDateTime;
begin
  inherited;
  //se o valor a Receber  menor ou igual a zero,  porque tem algo errado
  if StrToFloat(eReceber.Text) <= 0 then
  begin
    Alerta('Valor a Receber Incorreto!');
    eParticipante.SetFocus;
    abort;
  end;

  //solicita uma confirmao
  if not Confirma('Confirma o Pagamento dos Eventos Selecionados?') then
    exit;

  //recupera a data do pagamento neste instante, para usar em todos os registros
  data_pgto := Now;

  //desativa os controles
  cdsP.DisableControls;
  try
    //filtra no cdsP apenas os registros marcados para pagamento
    cdsP.Filtered := False;
    cdsP.Filter := 'PARTICIPA = ''T''';
    cdsP.Filtered := True;
    cdsP.First;

    //para cada registro marcado no cdsP
    while not cdsP.Eof do
    begin
      //filtra o evento correspondente nas participacoes da pessoa
      dm.cdsParticipacoes.Filtered := False;
      dm.cdsParticipacoes.Filter := 'CODEVENTO = ' + cdsPCODEVENTO.AsString;
      dm.cdsParticipacoes.Filtered := True;

      //edita o registro preenchendo a data do pagamento
      dm.cdsParticipacoes.Edit;
      dm.cdsParticipacoesPAGOEM.AsDateTime := data_pgto;
      dm.cdsParticipacoes.Post;

      cdsP.Next;
    end;

    //limpa o filtro realizado anteriormente
    dm.cdsParticipacoes.Filtered := False;
    dm.cdsParticipacoes.Filter := '';

    //grava no banco de dados as alteraes feitas no cdsParticipacoes, que
    //at ento, estava apenas em memria
    dm.Gravar(dm.cdsPessoa);

    //limpa o filtro do cdsP
    cdsP.Filtered := False;
    cdsP.Filter := '';
  finally
    //reativa os controles
    cdsP.EnableControls;
  end;

  //prepara a Janela para um novo recebimento
  Recomeca;
end;

procedure TfrmRecebimento.btCancelarClick(Sender: TObject);
begin
  //verifica se h alguma pessoa selecionada, sem o pagamento confirmado
  if not cdsP.IsEmpty then
  begin
    if not Confirma('Deseja sair sem confirmar o pagamento do participante atual?') then
    begin
      eRecebido.SetFocus;
      eRecebido.SelectAll;
      exit;
    end;
  end;

  //limpa algum possvel filtro que possa ter ficado no cdsParticipacoes
  dm.cdsParticipacoes.Filter := '';
  dm.cdsParticipacoes.Filtered := False;

  //continua com o processo normal de sada, feito no frmModeloCad
  inherited;
end;

procedure TfrmRecebimento.btLocalizaPessoaClick(Sender: TObject);
begin
  inherited;
  //limpa a varivel que guarda o cdigo da pessoa selecionada
  CodPessoa := -1;
  //exibe o for de consulta
  AbreFormCons(TfrmConsPessoa, frmConsPessoa);
  //se selecionou algum
  if CodPessoa>0 then
  begin
    //preenche o cdigo
    eParticipante.Text := IntToStr(CodPessoa);
    //e carrega os dados
    CarregaDados;
  end
  else
    //recoma o processo
    Recomeca;
end;

procedure TfrmRecebimento.eParticipanteKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  inherited;
  //se pressionar F3, executa o boto
  if key = vk_f3 then
    btLocalizaPessoa.Click
  //se pressionar ENTER, carrega os dados em tela
  else if key = VK_RETURN then
    CarregaDados;
end;

procedure TfrmRecebimento.eRecebidoEnter(Sender: TObject);
begin
  inherited;
  eRecebido.SelectAll;
end;

procedure TfrmRecebimento.eRecebidoExit(Sender: TObject);
begin
  inherited;
  //valida o valor digitado
  try
    eRecebido.Text := FormatFloat('#,##0.00', StrToFloat(eRecebido.Text));
  except on E: Exception do
    begin
      Alerta('O valor informado est incorreto!');
      eRecebido.SetFocus;
      abort;
    end;
  end;
  //chama o procedimento que calcula a diferena entre os valores
  calcula_diferenca;
end;

procedure TfrmRecebimento.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  inherited;
  //limpa o CDS, ocultando qualquer eventual exceo
  try cdsP.EmptyDataSet; except end;
end;

procedure TfrmRecebimento.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  inherited;
  //se pressionar F3, executa a pesquisa de Pessoas
  if key = vk_f3 then
    btLocalizaPessoa.Click;
end;

procedure TfrmRecebimento.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //se pressionar o Enter no DBGrid
  if (key = #13) and (gParticipacoes.Focused) then
  begin
    //posiciona o foco no campo de recebimento
    key := #0;
    eRecebido.SetFocus;
    exit;
  end;

  inherited;
end;

procedure TfrmRecebimento.FormShow(Sender: TObject);
begin
  inherited;
  //fecha o cdsPessoa, caso ativo
  if dm.cdsPessoa.Active then
    dm.cdsPessoa.Close;
  //ajusta os rtulos com os nomes dos grupos
  lGrupo1.Caption := NOME_GRUPO1;
  lGrupo2.Caption := NOME_GRUPO2;
  //posiciona o cursor no campo de pesquisa
  eParticipante.SetFocus;
end;

procedure TfrmRecebimento.gParticipacoesDblClick(Sender: TObject);
begin
  inherited;
  //se o cdsP est vazio, no adiante clicar duas vezes
  if cdsP.IsEmpty then
  begin
    Alerta('Nenhum Evento Cadastrado!');
    exit;
  end;

  try
    //edita o registro e inverte a condio atual da seleo
    cdsP.Edit;
    if cdsPPARTICIPA.AsBoolean then
      cdsPPARTICIPA.Value := 'F'
    else
      cdsPPARTICIPA.Value := 'T';
    cdsP.Post;
  except
  end;
end;

procedure TfrmRecebimento.gParticipacoesDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
begin
  inherited;
  //se o cdsP est vazio, encerra o procedimento
  if cdsP.IsEmpty then
    exit;

  //pinta o CheckBox, caso seja a coluna PARTICIPA
  if Column.Field=cdsPPARTICIPA then
  begin
    gParticipacoes.Canvas.FillRect(Rect);
    ImageList1.Draw(gParticipacoes.Canvas,Rect.Left+14,Rect.Top+1,0);
    if cdsPPARTICIPA.AsBoolean then
      ImageList1.Draw(gParticipacoes.Canvas,Rect.Left+14,Rect.Top+1,2)
    else
      ImageList1.Draw(gParticipacoes.Canvas,Rect.Left+14,Rect.Top+1,1);
  end;
end;

procedure TfrmRecebimento.gParticipacoesKeyPress(Sender: TObject;
  var Key: Char);
begin
  inherited;
  //se pressionar o espao, simula o duplo click da grid, para no
  //recodificar a seleo de registros neste evento
  if key = ' ' then
    gParticipacoesDblClick(gParticipacoes);
end;

end.
