unit uSorteio;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uFrmModeloCad, StdCtrls, Buttons, ExtCtrls, CheckLst, DB, DBClient;

type
  TfrmSorteio = class(TfrmModeloCad)
    pFiltro: TPanel;
    rEventos: TLabel;
    rGrupo1: TLabel;
    cListaEventos: TCheckListBox;
    cListaGrupo1: TCheckListBox;
    rSorteio: TLabel;
    rCodigo: TLabel;
    rNome: TLabel;
    rSorteados: TLabel;
    btn: TButton;
    Bevel1: TBevel;
    lSorteados: TListBox;
    pFoto: TPanel;
    img: TImage;
    cds: TClientDataSet;
    cdsID: TIntegerField;
    cdsCODPESSOA: TIntegerField;
    procedure FormShow(Sender: TObject);
    procedure btnClick(Sender: TObject);
  private
    { Private declarations }
    sorteando: Boolean;
    n: Integer;

    procedure prepara_selecao_presentes;
    procedure executa_sorteio;
    procedure parar_sorteio;
    procedure prepara_sorteio;
  public
    { Public declarations }
  end;

var
  frmSorteio: TfrmSorteio;

implementation

uses uDM, uLib;

{$R *.dfm}

procedure TfrmSorteio.prepara_sorteio;
var
  eventos, grupo1: String;
  i: Integer;
begin
  //recupera os cdigos dos eventos selecionados no cListaEventos
  eventos := '';
  for i := 0 to cListaEventos.Count - 1 do
    if cListaEventos.Checked[i] then
      eventos := eventos + Copy(
        cListaEventos.Items[i], 1,
        Pos('-',cListaEventos.Items[i])-1) + ',';
  if eventos <> '' then
    eventos := ' AND PA.CODEVENTO IN (' +
      Copy(eventos, 1, Length(eventos)-1) + ')';

  //recupera os cdigos dos grupos selecionados no cListaGrupo1
  grupo1 := '';
  for i := 0 to cListaGrupo1.Count - 1 do
    if cListaGrupo1.Checked[i] then
      grupo1 := grupo1 + Copy(
        cListaGrupo1.Items[i], 1,
        Pos('-',cListaGrupo1.Items[i])-1) + ',';
  if grupo1 <> '' then
    grupo1 := ' AND P.GRUPO1 IN (' +
      Copy(grupo1, 1, Length(grupo1)-1) + ')';

  //seleciona as pessoas presentes nos respectivos eventos
  //e dos respectivos grupos
  dm.cdsSorteio.Close;
  dm.qrySorteio.SQL.Text := 'SELECT DISTINCT P.CODPESSOA, P.NOME FROM PESSOAS P' +
    ' INNER JOIN PARTICIPACOES PA ON P.CODPESSOA = PA.CODPESSOA' +
    ' WHERE PA.PRESENTE = ''T''' + eventos + grupo1 + ' ORDER BY P.CODPESSOA';
  dm.cdsSorteio.Open;

  //se no encontrou ninguem, alerta e aborta
  if dm.cdsSorteio.IsEmpty then
  begin
    Alerta('Nenhum Participante Encontrado!');
    cListaEventos.SetFocus;
    abort;
  end;

  //caso contrrio, limpa o cds temporrio e o preenche com o id autonumrico
  //e com o cdigo de cada pessoa encontrada
  cds.EmptyDataSet;
  i := 1;
  while not dm.cdsSorteio.Eof do
  begin
    cds.AppendRecord([i,dm.cdsSorteioCODPESSOA.Value]);
    dm.cdsSorteio.Next;
    Inc(i);
  end;
  cds.First;

  //oculta o pFiltro e apresenta o pFoto
  pFiltro.Visible := False;
  pFoto.Visible := True;

  //Apresenta a quantidade de pessoas selecionadas, ou seja, a quantidade de
  //pessoas que esto concorrendo
  rNome.Caption := IntToStr(cds.RecordCount) +
    ' Participantes Selecionados!';

  //ajusta o caption do boto e posiciona o foco nele
  btn.Caption := 'INICIAR SORTEIO';
  btn.SetFocus;
  Application.ProcessMessages;
end;

procedure TfrmSorteio.executa_sorteio;
var
   i: Integer;
  b: boolean;
begin
  //limpa a foto atualmente exibida
  img.Picture.Assign(nil);

  //prepara os componentes em tela
  lSorteados.Enabled := False;
  btn.Caption := 'PARAR SORTEIO';
  rNome.Caption := 'Sorteando Participante...';

  //habilita a varivel de controle
  Sorteando := True;
  Application.ProcessMessages;

  //inicia o processo de randomizao
  Randomize;

  //enquanto a varivel for verdadeira, ela ir fazer os sorteios
  //aleatrios, conforme segue
  while sorteando do
  begin
    //sorteia um nmero entre 1 e o mximo permitido,
    //que  a (qtde. de registros no cds)
    n := Random(cds.RecordCount+1);

    //se sortear 0, faz virar 1 e se por acaso sortear maior que
    //o liminte, faz virar o limite
    if (n = 0) then
      n := 1
    else if n > cds.RecordCount then
      n := cds.RecordCount;

    //vai para o primeiro registroa e tenta localizar o nmero
    //sorteado no random pelo campo ID
    cds.First;
    if cds.Locate('ID', n, []) then
      try
        rCodigo.Caption := FormatFloat('0000000', cdsCODPESSOA.AsFloat);
      except
        rCodigo.Caption := cdsCODPESSOA.AsString;
      end;

    //processa as mensagems do sistema, at para poder detectar
    //o click no boto "Parar", com uma pequena pausa de 25 milissegundos
    //apenas para no ficar to rpido a ponto de no se ver os nmeros
    //sendo alterados em tela
    Application.ProcessMessages;
    Update;
    Sleep(25);
    Application.ProcessMessages;
  end;

  //quando sair do lao,  porque a varivel sorteando no 
  //mais verdadeira, ou seja, j clicaram no boto parar, sendo assim,
  //localizamos a pessoa no cdsSorteio do DataModule e apresentamos o seu
  //nome em tela
  dm.cdsSorteio.First;
  dm.cdsSorteio.Locate('CODPESSOA',cdsCODPESSOA.AsString,[]);
  rNome.Caption := dm.cdsSorteioNOME.AsString;

  //para exibir a foto em tela,  necessrio busca-la utilizando a qryAux
  dm.qryAux.Close;
  dm.qryAux.SQL.Text := 'SELECT FOTO FROM PESSOAS ' +
                        'WHERE CODPESSOA = ' + cdsCODPESSOA.AsString;
  dm.qryAux.Open;
  dm.carrega_foto_pessoa(TBlobField(dm.qryAux.FieldByName('FOTO')), img);
  dm.qryAux.Close;

  //aqui, fazemos a verificao para identificar se o sorteado
  //desta vez j no foi sorteado anteriormente
  b := False;
  for i := 0 to lSorteados.Count - 1 do
    if Pos(rCodigo.Caption, lSorteados.Items[i]) > 0 then
    begin
      b := True;
      break;
    end;
  if not b then
    lSorteados.Items.Add(rCodigo.Caption + '-' +
      dm.cdsSorteioNOME.AsString)
  else
    Alerta('PARTICIPANTE J FOI SORTEADO!!');

  //e por fim, volta os controle da tela como antes
  //para recomear o sorteio
  lSorteados.Enabled := True;
  btn.Caption := 'INICIAR SORTEIO';
  btn.SetFocus;
  Application.ProcessMessages;
end;

procedure TfrmSorteio.parar_sorteio;
begin
  //simplesmente altera a varivel "sorteando", para que o  mtodo
  //executa_sorteio faa seu trabalho, conforme comentado acima
  sorteando := False;
  Application.ProcessMessages;
end;

procedure TfrmSorteio.btnClick(Sender: TObject);
begin
  inherited;
  if btn.Caption = 'SELECIONAR PRESENTES' then
    prepara_sorteio
  else if btn.Caption = 'INICIAR SORTEIO' then
    executa_sorteio
  else if btn.Caption = 'PARAR SORTEIO' then
    parar_sorteio;
end;

procedure TfrmSorteio.FormShow(Sender: TObject);
begin
  inherited;

  //carrega lista de Eventos no cListaEventos
  dm.qryAux.Close;
  dm.qryAux.SQL.Text := 'SELECT CODEVENTO, DATA, NOME ' +
                        'FROM EVENTOS ORDER BY DATA, NOME';
  dm.qryAux.Open;
  cListaEventos.Items.BeginUpdate;
  try
    while not dm.qryAux.Eof do
    begin
      cListaEventos.Items.Add(
        dm.qryAux.FieldByName('CODEVENTO').AsString + '-' +
        dm.qryAux.FieldByName('DATA').AsString + '-' +
        dm.qryAux.FieldByName('NOME').AsString);
      dm.qryAux.Next;
    end;
  finally
    dm.qryAux.Close;
    cListaEventos.Items.EndUpdate;
  end;

  //preenche o rtulo rGrupo1 com o nome do grupo configurado
  //NOME_GRUPO1  uma varivel pblica no DataModule, que guarda
  //o nome utilizado para o Grupo
  rGrupo1.Caption := NOME_GRUPO1 + ':';

  //carrega lista de Grupos no cListaGrupos
  dm.qryAux.Close;
  dm.qryAux.SQL.Text := 'SELECT CODGRUPO, DESCRICAO ' +
                        'FROM GRUPO1 ORDER BY DESCRICAO';
  dm.qryAux.Open;
  cListaGrupo1.Items.BeginUpdate;
  try
    while not dm.qryAux.Eof do
    begin
      cListaGrupo1.Items.Add(dm.qryAux.FieldByName('CODGRUPO').AsString + '-' +
        dm.qryAux.FieldByName('DESCRICAO').AsString);
      dm.qryAux.Next;
    end;
  finally
    dm.qryAux.Close;
    cListaGrupo1.Items.EndUpdate;
  end;

  //mtodo do DataModule que marca ou desmarca todos os itens
  //de um CheckListBox, neste caso, para marcar todos os itens do cListaGrupo1
  dm.marca_desmarca(True, cListaGrupo1);

  //mtodo que prepara os componentes em tela para o incio do processo
  prepara_selecao_presentes;
end;

procedure TfrmSorteio.prepara_selecao_presentes;
begin
  btn.Caption := 'SELECIONAR PRESENTES';
  cListaEventos.Enabled := True;
  rCodigo.Caption := '0000000';
  rNome.Caption := 'Aguardando Seleo de Participantes...';
  Application.ProcessMessages;
end;

end.
